;; database name = connect string
;;
;; connect string params:
;;   dbname= host= port= user= password=
;;   client_encoding= datestyle= timezone=
;;   pool_size= connect_query=
; foodb over unix socket
;foodb =

; redirect bardb to bazdb on localhost
;bardb = host=localhost dbname=bazdb

; access to dest database will go with single user
;forcedb = host=127.0.0.1 port=300 user=baz password=foo client_encoding=UNICODE datestyle=ISO connect_query='SELECT 1'

; use custom pool sizes
;nondefaultdb = pool_size=50 reserve_pool_size=10

; fallback connect string
;* = host=testserver

;; Configuration section
[pgbouncer]

;;;
;;; Administrative settings
;;;

{% if pgbouncer_ini['logfile'] %}
logfile = {{ pgbouncer_ini['logfile'] }}
{% endif %}

pidfile = {{ pidfile }}

;;;
;;; Where to wait for clients
;;;

; ip address or * which means all ip-s
listen_addr = {{ pgbouncer_ini['listen_addr'] }}
listen_port = {{ listen_port }}

; unix socket is also used for -R.
; On debian it should be /var/run/postgresql
unix_socket_dir = {{ pgbouncer_ini['unix_socket_dir'] }}
unix_socket_mode = {{ pgbouncer_ini['unix_socket_mode'] }}
{% if pgbouncer_ini['unix_socket_group'] %}
unix_socket_group = {{ pgbouncer_ini['unix_socket_group'] }}
{% endif %}

;;;
;;; TLS settings for accepring clients
;;;

;; disable, allow, require, verify-ca, verify-full
client_tls_sslmode = {{ pgbouncer_ini['client_tls_sslmode'] }}

;; Path to file that contains trusted CA certs
{% if pgbouncer_ini['client_tls_ca_file'] %}
client_tls_ca_file = {{ pgbouncer_ini['client_tls_ca_file'] }}
{% endif %}

;; Private key and cert to present to clients.
;; Required for accepting TLS connections from clients.
{% if pgbouncer_ini['client_tls_key_file'] %}
client_tls_key_file = {{ pgbouncer_ini['client_tls_key_file'] }}
{% endif %}
{% if pgbouncer_ini['client_tls_cert_file'] %}
client_tls_cert_file = {{ pgbouncer_ini['client_tls_cert_file'] }}
{% endif %}

;; fast, normal, secure, legacy, <ciphersuite string>
client_tls_ciphers = {{ pgbouncer_ini['client_tls_ciphers'] }}

;; all, secure, tlsv1.0, tlsv1.1, tlsv1.2
client_tls_protocols = {{ pgbouncer_ini['client_tls_protocols'] }}

;; none, auto, legacy
client_tls_dheparams = {{ pgbouncer_ini['client_tls_dheparams'] }}

;; none, auto, <curve name>
client_tls_ecdhcurve = {{ pgbouncer_ini['client_tls_ecdhcurve'] }}

;;;
;;; TLS settings for connecting to backend databases
;;;

;; disable, allow, require, verify-ca, verify-full
server_tls_sslmode = {{ pgbouncer_ini['server_tls_sslmode'] }}

;; Path to that contains trusted CA certs
{% if pgbouncer_ini['server_tls_ca_file'] %}
server_tls_ca_file = {{ pgbouncer_ini['server_tls_ca_file'] }}
{% endif %}

;; Private key and cert to present to backend.
;; Needed only if backend server require client cert.
{% if pgbouncer_ini['server_tls_key_file'] %}
server_tls_key_file = {{ pgbouncer_ini['server_tls_key_file'] }}
{% endif %}
{% if pgbouncer_ini['server_tls_cert_file'] %}
server_tls_cert_file = {{ pgbouncer_ini['server_tls_cert_file'] }}
{% endif %}

;; all, secure, tlsv1.0, tlsv1.1, tlsv1.2
server_tls_protocols = {{ pgbouncer_ini['server_tls_protocols'] }}

;; fast, normal, secure, legacy, <ciphersuite string>
server_tls_ciphers = {{ pgbouncer_ini['server_tls_ciphers'] }}

;;;
;;; Authentication settings
;;;

; any, trust, plain, crypt, md5
auth_type = {{ pgbouncer_ini['auth_type'] }}
;auth_file = /8.0/main/global/pg_auth
auth_file = {{ pgbouncer_data_directory }}/pg_auth

{% if pgbouncer_ini['auth_hba_file'] %}
;; Path to HBA-style auth config
auth_hba_file = {{ pgbouncer_ini['auth_hba_file'] }}
{% endif %}

;; Query to use to fetch password from database.  Result
;; must have 2 columns - username and password hash.
auth_query = {{ pgbouncer_ini['auth_query'] }}
;;;
;;; Users allowed into database 'pgbouncer'
;;;

; comma-separated list of users, who are allowed to change settings
admin_users = {{ pgbouncer_ini['admin_users'] | join(', ') }}

; comma-separated list of users who are just allowed to use SHOW command
stats_users = {{ pgbouncer_ini['stats_users'] | join(', ') }}

;;;
;;; Pooler personality questions
;;;

; When server connection is released back to pool:
;   session      - after client disconnects
;   transaction  - after transaction finishes
;   statement    - after statement finishes
pool_mode = {{ pgbouncer_ini['pool_mode'] }}

;
; Query for cleaning connection immediately after releasing from client.
; No need to put ROLLBACK here, pgbouncer does not reuse connections
; where transaction is left open.
;
; Query for 8.3+:
;   DISCARD ALL;
;
; Older versions:
;   RESET ALL; SET SESSION AUTHORIZATION DEFAULT
;
; Empty if transaction pooling is in use.
;
server_reset_query = {{ pgbouncer_ini['server_reset_query'] }}


; Whether server_reset_query should run in all pooling modes.
; If it is off, server_reset_query is used only for session-pooling.
server_reset_query_always = {{ pgbouncer_ini['server_reset_query_always'] }}

;
; Comma-separated list of parameters to ignore when given
; in startup packet.  Newer JDBC versions require the
; extra_float_digits here.
;
ignore_startup_parameters = {{ pgbouncer_ini['ignore_startup_parameters'] }}

;
; When taking idle server into use, this query is ran first.
;   SELECT 1
;
server_check_query = {{ pgbouncer_ini['server_check_query'] }}

; If server was used more recently that this many seconds ago,
; skip the check query.  Value 0 may or may not run in immediately.
server_check_delay = {{ pgbouncer_ini['server_check_delay'] }}

;; Use <appname - host> as application_name on server.
application_name_add_host = {{ pgbouncer_ini['application_name_add_host'] }}

;;;
;;; Connection limits
;;;

; total number of clients that can connect
max_client_conn = {{ pgbouncer_ini['max_client_conn'] }}

; default pool size.  20 is good number when transaction pooling
; is in use, in session pooling it needs to be the number of
; max clients you want to handle at any moment
default_pool_size = {{ pgbouncer_ini['default_pool_size'] }}

;; Minimum number of server connections to keep in pool.
min_pool_size = {{ pgbouncer_ini['min_pool_size'] }}

; how many additional connection to allow in case of trouble
reserve_pool_size = {{ pgbouncer_ini['reserve_pool_size'] }}

; if a clients needs to wait more than this many seconds, use reserve pool
reserve_pool_timeout = {{ pgbouncer_ini['reserve_pool_timeout'] }}

; how many total connections to a single database to allow from all pools
{% if pgbouncer_ini['max_db_connections'] %}
max_db_connections = {{ pgbouncer_ini['max_db_connections'] }}
{% endif %}
{% if pgbouncer_ini['max_user_connections'] %}
max_user_connections = {{ pgbouncer_ini['max_user_connections'] }}
{% endif %}

; If off, then server connections are reused in LIFO manner
server_round_robin = {{ pgbouncer_ini['server_round_robin'] }}

;;;
;;; Logging
;;;

;; Syslog settings
syslog = {{ pgbouncer_ini['syslog'] }}
syslog_facility = {{ pgbouncer_ini['syslog_facility'] }}
syslog_ident = {{ pgbouncer_ini['syslog_ident'] }}

; log if client connects or server connection is made
log_connections = {{ pgbouncer_ini['log_connections'] }}

; log if and why connection was closed
log_disconnections = {{ pgbouncer_ini['log_disconnections'] }}

; log error messages pooler sends to clients
log_pooler_errors = {{ pgbouncer_ini['log_pooler_errors'] }}

;; Period for writing aggregated stats into log.
stats_period = {{ pgbouncer_ini['stats_period'] }}

;; Logging verbosity.  Same as -v switch on command line.
verbose = {{ pgbouncer_ini['verbose'] }}

;;;
;;; Timeouts
;;;

;; Close server connection if its been connected longer.
server_lifetime = {{ pgbouncer_ini['server_lifetime'] }}

;; Close server connection if its not been used in this time.
;; Allows to clean unnecessary connections from pool after peak.
server_idle_timeout = {{ pgbouncer_ini['server_idle_timeout'] }}

;; Cancel connection attempt if server does not answer takes longer.
server_connect_timeout = {{ pgbouncer_ini['server_connect_timeout'] }}

;; If server login failed (server_connect_timeout or auth failure)
;; then wait this many second.
server_login_retry = {{ pgbouncer_ini['server_login_retry'] }}

;; Dangerous.  Server connection is closed if query does not return
;; in this time.  Should be used to survive network problems,
;; _not_ as statement_timeout. (default: 0)
query_timeout = {{ pgbouncer_ini['query_timeout'] }}

;; Dangerous.  Client connection is closed if the query is not assigned
;; to a server in this time.  Should be used to limit the number of queued
;; queries in case of a database or network failure. (default: 120)
query_wait_timeout = {{ pgbouncer_ini['query_wait_timeout'] }}

;; Dangerous.  Client connection is closed if no activity in this time.
;; Should be used to survive network problems. (default: 0)
client_idle_timeout = {{ pgbouncer_ini['client_idle_timeout'] }}

;; Disconnect clients who have not managed to log in after connecting
;; in this many seconds.
client_login_timeout = {{ pgbouncer_ini['client_login_timeout'] }}

;; Clean automatically created database entries (via "*") if they
;; stay unused in this many seconds.
autodb_idle_timeout = {{ pgbouncer_ini['autodb_idle_timeout'] }}

;; How long SUSPEND/-R waits for buffer flush before closing connection.
suspend_timeout = {{ pgbouncer_ini['suspend_timeout'] }}

;; Close connections which are in "IDLE in transaction" state longer than
;; this many seconds.
idle_transaction_timeout = {{ pgbouncer_ini['idle_transaction_timeout'] }}

;;;
;;; Low-level tuning options
;;;

;; buffer for streaming packets
pkt_buf = {{ pgbouncer_ini['pkt_buf'] }}

;; man 2 listen
listen_backlog = {{ pgbouncer_ini['listen_backlog'] }}

;; Max number pkt_buf to process in one event loop.
sbuf_loopcnt = {{ pgbouncer_ini['sbuf_loopcnt'] }}

;; Maximum Postgres protocol packet size.
max_packet_size = {{ pgbouncer_ini['max_packet_size'] }}

;; networking options, for info: man 7 tcp

;; Linux: notify program about new connection only if there
;; is also data received.  (Seconds to wait.)
;; On Linux the default is 45, on other OS'es 0.
tcp_defer_accept = {{ pgbouncer_ini['tcp_defer_accept'] }}

;; In-kernel buffer size (Linux default: 4096)
tcp_socket_buffer = {{ pgbouncer_ini['tcp_socket_buffer'] }}

;; whether tcp keepalive should be turned on (0/1)
tcp_keepalive = {{ pgbouncer_ini['tcp_keepalive'] }}

;; following options are Linux-specific.
;; they also require tcp_keepalive=1

;; count of keepaliva packets
tcp_keepcnt = {{ pgbouncer_ini['tcp_keepcnt'] }}

;; how long the connection can be idle,
;; before sending keepalive packets
tcp_keepidle = {{ pgbouncer_ini['tcp_keepidle'] }}

;; The time between individual keepalive probes.
tcp_keepintvl = {{ pgbouncer_ini['tcp_keepintvl'] }}

;; DNS lookup caching time
dns_max_ttl = {{ pgbouncer_ini['dns_max_ttl'] }}

;; DNS zone SOA lookup period
dns_zone_check_period = {{ pgbouncer_ini['dns_zone_check_period'] }}

;; DNS negative result caching time
dns_nxdomain_ttl = {{ pgbouncer_ini['dns_nxdomain_ttl'] }}

;;;
;;; Random stuff
;;;

;; Hackish security feature.  Helps against SQL-injection - when PQexec is disabled,
;; multi-statement cannot be made.
disable_pqexec = {{ pgbouncer_ini['disable_pqexec'] }}

;; Config file to use for next RELOAD/SIGHUP.
;; By default contains config file from command line.
;conffile

;; Win32 service name to register as.  job_name is alias for service_name,
;; used by some Skytools scripts.
;service_name = pgbouncer
;job_name = pgbouncer

;; Read additional config from the /etc/pgbouncer/pgbouncer-other.ini file
;%include /etc/pgbouncer/pgbouncer-other.ini
%include {{ pgbouncer_ini['databases_ini'] }}
